Index: palm/trunk/SOURCE/pmc_interface.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface.f90	(revision 1763)
+++ palm/trunk/SOURCE/pmc_interface.f90	(revision 1764)
@@ -1079,5 +1166,6 @@
             k   = kb + 1
             wall_index = kb 
-            CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j, inc, wall_index, z0(j,i), kb, direction, ncorr )
+            CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j, inc, &
+                                     wall_index, z0(j,i), kb, direction, ncorr )
             logc_u_r(k,j,1) = lc
             logc_ratio_u_r(k,j,1,0:ncorr-1) = lcr(0:ncorr-1)
@@ -1090,13 +1178,15 @@
             k   = kb + 1
             wall_index = kb 
-            CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j, inc, wall_index, z0(j,i), kb, direction, ncorr )
+            CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j, inc, &
+                                     wall_index, z0(j,i), kb, direction, ncorr )
             logc_v_r(k,j,1) = lc
             logc_ratio_v_r(k,j,1,0:ncorr-1) = lcr(0:ncorr-1)
             lcr(0:ncorr-1) = 1.0_wp
-         ENDDO
-      ENDIF
-
-!
-!--   South boundary.
+
+         ENDDO
+      ENDIF
+
+!
+!--   South boundary
       IF ( nest_bound_s )  THEN
          ALLOCATE( logc_u_s(nzb:nzt_topo_nestbc_s,nxl:nxr,1:2) )
@@ -1111,5 +1201,4 @@
          inc            = 1 
          DO  i = nxl, nxr
-
 !
 !--         South boundary for u.
@@ -1118,5 +1207,6 @@
             k   =  kb + 1
             wall_index = kb 
-            CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j, inc, wall_index, z0(j,i), kb, direction, ncorr )
+            CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j, inc, &
+                                     wall_index, z0(j,i), kb, direction, ncorr )
             logc_u_s(k,i,1) = lc
             logc_ratio_u_s(k,i,1,0:ncorr-1) = lcr(0:ncorr-1)
@@ -1124,10 +1214,11 @@
 
 !
-!--         South boundary for v.
+!--         South boundary for v
             j   = 0
             kb  = nzb_v_inner(j,i)
             k   = kb + 1
             wall_index = kb 
-            CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j, inc, wall_index, z0(j,i), kb, direction, ncorr )
+            CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j, inc, &
+                                     wall_index, z0(j,i), kb, direction, ncorr )
             logc_v_s(k,i,1) = lc
             logc_ratio_v_s(k,i,1,0:ncorr-1) = lcr(0:ncorr-1)
@@ -1137,5 +1228,5 @@
 
 !
-!--   North boundary.
+!--   North boundary
       IF ( nest_bound_n )  THEN
          ALLOCATE( logc_u_n(nzb:nzt_topo_nestbc_n,nxl:nxr,1:2) )
@@ -1149,6 +1240,5 @@
          direction      = 1
          inc            = 1 
-         DO  i = nxl, nxr       
-
+         DO  i = nxl, nxr
 !
 !--         North boundary for u.
@@ -1157,5 +1247,6 @@
             k   = kb + 1
             wall_index = kb 
-            CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j, inc, wall_index, z0(j,i), kb, direction, ncorr )
+            CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j, inc, &
+                                     wall_index, z0(j,i), kb, direction, ncorr )
             logc_u_n(k,i,1) = lc
             logc_ratio_u_n(k,i,1,0:ncorr-1) = lcr(0:ncorr-1)
@@ -1168,8 +1259,10 @@
             k   = kb + 1
             wall_index = kb 
-            CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j, inc, wall_index, z0(j,i), kb, direction, ncorr )
+            CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j, inc, &
+                                     wall_index, z0(j,i), kb, direction, ncorr )
             logc_v_n(k,i,1) = lc
             logc_ratio_v_n(k,i,1,0:ncorr-1) = lcr(0:ncorr-1)
             lcr(0:ncorr-1) = 1.0_wp
+
          ENDDO
       ENDIF
@@ -2011,5 +2104,5 @@
     END SUBROUTINE pmci_init_tkefactor
 
-
+#endif
  END SUBROUTINE pmci_setup_client
 
@@ -2017,5 +2110,8 @@
 
  SUBROUTINE pmci_setup_coordinates
+
+#if defined( __parallel )
     IMPLICIT NONE
+
     INTEGER(iwp) ::  i   !:
     INTEGER(iwp) ::  j   !:
@@ -2033,5 +2129,6 @@
        coord_y(j) = lower_left_coord_y + j * dy
     ENDDO
-     
+
+#endif
  END SUBROUTINE pmci_setup_coordinates
 
@@ -2040,4 +2137,5 @@
  SUBROUTINE pmci_server_synchronize
 
+#if defined( __parallel )
 !
 !-- Unify the time steps for each model and synchronize.
@@ -2066,5 +2164,5 @@
 !
 !-- Broadcast the unified time step to all server processes.
-    CALL MPI_Bcast( dt_3d, 1, MPI_REAL, 0, comm2d, ierr )
+    CALL MPI_BCAST( dt_3d, 1, MPI_REAL, 0, comm2d, ierr )
 
 !
@@ -2076,5 +2174,6 @@
        ENDIF
     ENDDO
-    
+
+#endif
  END SUBROUTINE pmci_server_synchronize
 
@@ -2083,4 +2182,5 @@
  SUBROUTINE pmci_client_synchronize
 
+#if defined( __parallel )
 !
 !-- Unify the time steps for each model and synchronize.
@@ -2105,7 +2205,8 @@
 !
 !--    Broadcast the unified time step to all server processes.
-       CALL MPI_Bcast( dt_3d, 1, MPI_REAL, 0, comm2d, ierr )
+       CALL MPI_BCAST( dt_3d, 1, MPI_REAL, 0, comm2d, ierr )
     ENDIF
 
+#endif
  END SUBROUTINE pmci_client_synchronize
                 
@@ -2113,6 +2214,10 @@
 
  SUBROUTINE pmci_server_datatrans( direction )
+
     IMPLICIT NONE
+
     INTEGER(iwp),INTENT(IN) ::  direction   !:
+
+#if defined( __parallel )
     INTEGER(iwp)            ::  client_id   !:
     INTEGER(iwp)            ::  i           !:
@@ -2138,5 +2243,5 @@
 !
 !-- Broadcast the unified time step to all server processes.
-    CALL MPI_Bcast( dt_3d, 1, MPI_REAL, 0, comm2d, ierr )
+    CALL MPI_BCAST( dt_3d, 1, MPI_REAL, 0, comm2d, ierr )
 
     DO  m = 1, SIZE( PMC_Server_for_Client ) - 1
@@ -2185,4 +2290,5 @@
     ENDDO
 
+#endif
  END SUBROUTINE pmci_server_datatrans
 
@@ -2190,6 +2296,10 @@
 
  SUBROUTINE pmci_client_datatrans( direction )
+
     IMPLICIT NONE
+
     INTEGER(iwp), INTENT(IN) ::  direction   !:
+
+#if defined( __parallel )
     INTEGER(iwp)             ::  ierr        !:
     INTEGER(iwp)             ::  icl         !:
@@ -2214,5 +2324,5 @@
 !
 !--    Broadcast the unified time step to all server processes.
-       CALL MPI_Bcast( dt_3d, 1, MPI_REAL, 0, comm2d, ierr )
+       CALL MPI_BCAST( dt_3d, 1, MPI_REAL, 0, comm2d, ierr )
        CALL cpu_log( log_point_s(70), 'PMC model sync', 'stop' )
 
@@ -3179,4 +3289,5 @@
 !--            Spatial under-relaxation.
                fra  = frax(l) * fray(m) * fraz(n)
+!--            TO_DO: why not KIND=wp ?
                fc(n,m,l) = ( 1.0_wp - fra ) * fc(n,m,l) + fra * cellsum / REAL( nfc, KIND=KIND(cellsum) )  
             ENDDO
@@ -3186,5 +3297,5 @@
    END SUBROUTINE pmci_anterp_tophat
 
-
+#endif
  END SUBROUTINE pmci_client_datatrans
 
@@ -3193,4 +3304,5 @@
  SUBROUTINE pmci_update_new
 
+#if defined( __parallel )
 !
 !-- Copy the interpolated/anterpolated boundary values to the _p 
@@ -3219,5 +3331,6 @@
 
 !
-!-- Find out later if nesting would work without __nopointer.
+!-- TO_DO: Find out later if nesting would work without __nopointer.
+#endif
 
  END SUBROUTINE pmci_update_new
@@ -3226,4 +3339,5 @@
 
  SUBROUTINE pmci_set_array_pointer( name, client_id, nz_cl )
+
     IMPLICIT NONE
 
@@ -3232,4 +3346,5 @@
     CHARACTER(LEN=*), INTENT(IN)         ::  name        !:
     
+#if defined( __parallel )
     REAL(wp), POINTER, DIMENSION(:,:)    ::  p_2d        !:
     REAL(wp), POINTER, DIMENSION(:,:,:)  ::  p_3d        !:
@@ -3238,5 +3353,4 @@
     
 
-#if defined PMC_ACTIVE
     NULLIFY( p_3d )
     NULLIFY( p_2d )
@@ -3257,10 +3371,19 @@
        CALL pmc_s_set_dataarray( client_id, p_2d )
     ELSE
-       IF ( myid == 0 ) WRITE( 0, * )  'PMC set_array_Pointer -> no pointer p_2d or p_3d associated '
-       CALL MPI_Abort( MPI_COMM_WORLD, istat, ierr )
+!
+!--    Give only one message for the root domain
+       IF ( myid == 0  .AND.  cpl_id == 1 )  THEN
+
+          message_string = 'pointer for array "' // TRIM( name ) //            &
+                           '" can''t be associated'
+          CALL message( 'pmci_set_array_pointer', 'PA0117', 3, 2, 0, 6, 0 )
+       ELSE
+!
+!--       Avoid others to continue
+          CALL MPI_BARRIER( comm2d, ierr )
+       ENDIF
     ENDIF
 
 #endif
-
  END SUBROUTINE pmci_set_array_pointer
 
@@ -3268,5 +3391,7 @@
 
  SUBROUTINE pmci_create_client_arrays( name, is, ie, js, je, nzc  )
+
     IMPLICIT NONE
+
     INTEGER(iwp), INTENT(IN)              ::  ie      !:
     INTEGER(iwp), INTENT(IN)              ::  is      !:
@@ -3276,4 +3401,5 @@
     CHARACTER(LEN=*), INTENT(IN)          ::  name    !:
      
+#if defined( __parallel )
     REAL(wp), POINTER,DIMENSION(:,:)      ::  p_2d    !:
     REAL(wp), POINTER,DIMENSION(:,:,:)    ::  p_3d    !:
@@ -3282,5 +3408,4 @@
 
 
-#if defined PMC_ACTIVE
     NULLIFY( p_3d )
     NULLIFY( p_2d )
@@ -3317,9 +3442,19 @@
        CALL pmc_c_set_dataarray( p_2d )
     ELSE
-       IF ( myid == 0 ) WRITE( 0 , * )  'PMC create_client_arrays -> no pointer p_2d or p_3d associated '
-       CALL MPI_Abort( MPI_COMM_WORLD, istat, ierr )
+!
+!--    Give only one message for the first client domain
+       IF ( myid == 0  .AND.  cpl_id == 2 )  THEN
+
+          message_string = 'pointer for array "' // TRIM( name ) //            &
+                           '" can''t be associated'
+          CALL message( 'pmci_create_client_arrays', 'PA0170', 3, 2, 0, 6, 0 )
+       ELSE
+!
+!--       Avoid others to continue
+          CALL MPI_BARRIER( comm2d, ierr )
+       ENDIF
     ENDIF
+
 #endif
-
  END SUBROUTINE pmci_create_client_arrays
 
@@ -3327,5 +3462,8 @@
 
  SUBROUTINE pmci_server_initialize
+
+#if defined( __parallel )
     IMPLICIT NONE
+
     INTEGER(iwp)   ::  client_id   !:
     INTEGER(iwp)   ::  m           !:
@@ -3338,4 +3476,5 @@
     ENDDO
 
+#endif
  END SUBROUTINE pmci_server_initialize
 
@@ -3344,5 +3483,7 @@
  SUBROUTINE pmci_client_initialize
 
+#if defined( __parallel )
     IMPLICIT NONE
+
     INTEGER(iwp)   ::  i          !:
     INTEGER(iwp)   ::  icl        !:
@@ -3428,6 +3569,8 @@
       INTEGER(iwp) ::  i      !:
       INTEGER(iwp) ::  ib     !:
+      INTEGER(iwp) ::  ie     !:
       INTEGER(iwp) ::  j      !:
       INTEGER(iwp) ::  jb     !:
+      INTEGER(iwp) ::  je     !:
       INTEGER(iwp) ::  k      !:
       INTEGER(iwp) ::  k1     !:
@@ -3448,21 +3591,31 @@
       
       ib = nxl
-      jb = nys     
+      ie = nxr
+      jb = nys   
+      je = nyn
       IF ( nest_bound_l )  THEN
+         ib = nxl - 1 
          IF ( var == 'u' )  THEN   !  For u, nxl is a ghost node, but not for the other variables.
-            ib = nxl + 1
+            ib = nxl
          ENDIF
       ENDIF
       IF ( nest_bound_s )  THEN
+         jb = nys - 1 
          IF ( var == 'v' )  THEN   !  For v, nys is a ghost node, but not for the other variables.
-            jb = nys + 1
+            jb = nys
          ENDIF
       ENDIF
+      IF ( nest_bound_r )  THEN
+         ie = nxr + 1
+      ENDIF
+      IF ( nest_bound_n )  THEN
+         je = nyn + 1
+      ENDIF
 
 !
 !--   Trilinear interpolation.
-      DO  i = ib, nxr
-         DO  j = jb, nyn
-            DO  k = kb(j,i), nzt 
+      DO  i = ib, ie
+         DO  j = jb, je
+            DO  k = kb(j,i), nzt + 1 
                l = ic(i)
                m = jc(j)
@@ -3517,4 +3670,5 @@
    END SUBROUTINE pmci_interp_tril_all
 
+#endif
  END SUBROUTINE pmci_client_initialize
 
@@ -3523,4 +3677,5 @@
  SUBROUTINE pmci_ensure_nest_mass_conservation
 
+#if defined( __parallel )
 !
 !-- Adjust the volume-flow rate through the top boundary 
@@ -3635,4 +3790,5 @@
     ENDDO
 
+#endif
  END SUBROUTINE pmci_ensure_nest_mass_conservation
 
Index: palm/trunk/SOURCE/pmc_mpi_wrapper.f90
===================================================================
--- palm/trunk/SOURCE/pmc_mpi_wrapper.f90	(revision 1763)
+++ palm/trunk/SOURCE/pmc_mpi_wrapper.f90	(revision 1764)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! ------------------
-!
+! cpp-statement added (nesting can only be used in parallel mode),
+! kind-parameters adjusted to PALM-kinds
 !
 ! Former revisions:
@@ -35,8 +36,13 @@
 !------------------------------------------------------------------------------!
 
+#if defined( __parallel )
    use, intrinsic :: iso_c_binding
 
-   USE  mpi
-   USE  kinds,         ONLY: wp
+#if defined( __lc )
+    USE MPI
+#else
+    INCLUDE "mpif.h"
+#endif
+   USE  kinds
    USE  PMC_handle_communicator, ONLY: m_to_server_comm, m_to_client_comm, m_model_comm, m_model_rank
    IMPLICIT none
@@ -44,5 +50,7 @@
    SAVE
 
-   INTEGER, PARAMETER :: dp = wp
+!-- TO_DO: what is the meaning of this? Could variables declared in this module
+!--        also have single precision?
+!   INTEGER, PARAMETER :: dp = wp
 
 
@@ -149,4 +157,6 @@
    SUBROUTINE  PMC_Send_to_Server_real_r1 (buf, n, Server_rank, tag, ierr)
       IMPLICIT     none
+!--   TO_DO: has buf always to be of dp-kind, or can wp used here
+!--          this effects all respective declarations in this file
       REAL(kind=dp), DIMENSION(:), INTENT(IN)   :: buf
       INTEGER, INTENT(IN)                       :: n
@@ -485,5 +495,5 @@
       IMPLICIT     none
       REAL(kind=wp),DIMENSION(:),POINTER,INTENT(INOUT) :: array
-      INTEGER(kind=8),INTENT(IN)                       :: idim1
+      INTEGER(idp),INTENT(IN)                          :: idim1
       Type(c_ptr),INTENT(OUT),optional                 :: base_ptr
 
@@ -516,3 +526,4 @@
     END FUNCTION PMC_TIME
 
+#endif
  END MODULE pmc_mpi_wrapper
Index: palm/trunk/SOURCE/pmc_server.f90
===================================================================
--- palm/trunk/SOURCE/pmc_server.f90	(revision 1763)
+++ palm/trunk/SOURCE/pmc_server.f90	(revision 1764)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-!
+! cpp-statement added (nesting can only be used in parallel mode)
 !
 ! Former revisions:
@@ -35,8 +35,13 @@
 !------------------------------------------------------------------------------!
 
+#if defined( __parallel )
    use, intrinsic :: iso_c_binding
 
-   USE  mpi
-   USE  kinds,                     ONLY: wp, iwp
+#if defined( __lc )
+    USE MPI
+#else
+    INCLUDE "mpif.h"
+#endif
+   USE  kinds
    USE  PMC_general,               ONLY: ClientDef, PMC_MAX_MODELL,PMC_sort, DA_NameDef, DA_Desclen, DA_Namelen,       &
                                          PMC_G_SetName, PMC_G_GetName, PeDef, ArrayDef
@@ -60,5 +65,7 @@
    PUBLIC PMC_Server_for_Client
 
-   INTEGER, PARAMETER :: dp = wp
+!-- TO_DO: what is the meaning of this? Could variables declared in this module
+!--        also have single precision?
+!   INTEGER, PARAMETER :: dp = wp
 
    ! INTERFACE section
@@ -225,4 +232,6 @@
         IMPLICIT none
         INTEGER,INTENT(IN)                         :: ClientId
+!--   TO_DO: has array always to be of dp-kind, or can wp used here
+!--          this effects all respective declarations in this file
         REAL(kind=dp),INTENT(IN),DIMENSION(:,:)    :: array
         !-- local variables
@@ -282,5 +291,5 @@
       INTEGER                                 :: arlen, myIndex, tag
       INTEGER                                 :: rCount                    ! count MPI requests
-      INTEGER(kind=8)                         :: bufsize                   ! Size of MPI data Window
+      INTEGER(idp)                            :: bufsize                   ! Size of MPI data Window
       TYPE(PeDef),POINTER                     :: aPE
       TYPE(ArrayDef),POINTER                  :: ar
@@ -347,6 +356,8 @@
          do while (PMC_S_GetNextArray ( ClientId, myName,i))
             ar  => aPE%Arrays
+!--         TO_DO:  Adressrechnung ueberlegen?
             ar%SendBuf = c_loc(base_array(ar%BufIndex))                         !kk Adressrechnung ueberlegen
             if(ar%BufIndex+ar%BufSize > bufsize) then
+!--            TO_DO: can this error really happen, and what can be the reason?
                write(0,'(a,i4,4i7,1x,a)') 'Buffer too small ',i,ar%BufIndex,ar%BufSize,ar%BufIndex+ar%BufSize,bufsize,trim(myName)
                CALL MPI_Abort (MPI_COMM_WORLD, istat, ierr)
@@ -402,4 +413,5 @@
                end do
             else
+!--            TO_DO: can this error really happen, and what can be the reason?
                write(0,*) "Illegal Order of Dimension ",ar%dim_order
                CALL MPI_Abort (MPI_COMM_WORLD, istat, ierr);
@@ -458,4 +470,5 @@
                end do
             else
+!--            TO_DO: can this error really happen, and what can be the reason?
                write(0,*) "Illegal Order of Dimension ",ar%dim_order
                CALL MPI_Abort (MPI_COMM_WORLD, istat, ierr);
@@ -624,3 +637,4 @@
     END SUBROUTINE Set_PE_index_list
 
+#endif
 END MODULE pmc_server
Index: palm/trunk/SOURCE/time_integration.f90
===================================================================
--- palm/trunk/SOURCE/time_integration.f90	(revision 1763)
+++ palm/trunk/SOURCE/time_integration.f90	(revision 1764)
@@ -19,5 +19,6 @@
 ! Current revisions:
 ! ------------------
-!
+! PMC_ACTIVE flags removed,
+! nest synchronization after first call of timestep
 !
 ! Former revisions:
@@ -238,12 +239,10 @@
     USE pegrid
 
-#if defined( PMC_ACTIVE )
     USE pmc_interface,                                                         &
-        ONLY:  client_to_server, nesting_mode,                                 &
+        ONLY:  client_to_server, nested_run, nesting_mode,                     &
                pmci_ensure_nest_mass_conservation, pmci_client_datatrans,      &
                pmci_client_initialize, pmci_client_synchronize,                &
                pmci_server_datatrans, pmci_server_initialize,                  &
                pmci_server_synchronize, pmci_update_new, server_to_client
-#endif
 
     USE production_e_mod,                                                      &
@@ -282,6 +281,13 @@
     IF ( simulated_time == 0.0_wp )  CALL timestep
 
+!
+!-- Synchronize the timestep in case of nested run.
+!-- The server side must be called first
+    IF ( nested_run )  THEN
+       CALL pmci_server_synchronize
+       CALL pmci_client_synchronize
+    ENDIF
+
     CALL run_control
-
 
 !
@@ -302,48 +308,49 @@
     ENDIF
 
-#if defined( PMC_ACTIVE )
-!
-!-- TO_DO: try to give more meaningful comments here
-!-- Domain nesting: From server to client commmunication
-!-- ( direction=SERVER_TO_CLIENT )
-!-- Nest initial conditions
-!
-!-- Send initial condition data from server to client
-    CALL pmci_server_initialize
-!
-!-- Receive and interpolate initial data on client
-    CALL pmci_client_initialize
-!
-!-- TO_DO, maybe removed
-!-- Obs. Nesting may be unnecessary at this point.
-!
-!-- Nest boundary conditions
-    CALL pmci_server_datatrans( server_to_client )
-    CALL pmci_client_datatrans( server_to_client )
-
-    IF ( nesting_mode == 'two-way' )  THEN
-       CALL pmci_server_datatrans( client_to_server )
-       CALL pmci_client_datatrans( client_to_server )
-!
-!--    Exchange_horiz is needed for all server-domains after the anterpolation
-       CALL exchange_horiz( u, nbgp )
-       CALL exchange_horiz( v, nbgp )
-       CALL exchange_horiz( w, nbgp )
-       CALL exchange_horiz( pt, nbgp )
-       IF ( .NOT. constant_diffusion )  CALL exchange_horiz( e, nbgp )
-       intermediate_timestep_count = 0
-       CALL pres
+    IF ( nested_run )  THEN
+!
+!--    TO_DO: try to give more meaningful comments here
+!--    Domain nesting: From server to client commmunication
+!--    ( direction=SERVER_TO_CLIENT )
+!--    Nest initial conditions
+!
+!--    Send initial condition data from server to client
+       CALL pmci_server_initialize
+!
+!--    Receive and interpolate initial data on client
+       CALL pmci_client_initialize
+!
+!--    TO_DO, maybe removed
+!--    Obs. Nesting may be unnecessary at this point.
+!
+!--    Nest boundary conditions
+       CALL pmci_server_datatrans( server_to_client )
+       CALL pmci_client_datatrans( server_to_client )
+
+       IF ( nesting_mode == 'two-way' )  THEN
+          CALL pmci_server_datatrans( client_to_server )
+          CALL pmci_client_datatrans( client_to_server )
+!
+!--       Exchange_horiz is needed for all server-domains after the anterpolation
+          CALL exchange_horiz( u, nbgp )
+          CALL exchange_horiz( v, nbgp )
+          CALL exchange_horiz( w, nbgp )
+          CALL exchange_horiz( pt, nbgp )
+          IF ( .NOT. constant_diffusion )  CALL exchange_horiz( e, nbgp )
+          intermediate_timestep_count = 0
+          CALL pres
+       ENDIF
+!
+!--    Correct the w top-BC in nest domains to ensure mass conservation.
+!--    Copy the interpolated/anterpolated boundary values to the _p
+!--    arrays, too, to make sure the interpolated/anterpolated boundary
+!--    values are carried over from one RK inner step to another.
+!--    These actions must not be done for the root domain.
+       IF ( nest_domain )  THEN
+          CALL pmci_ensure_nest_mass_conservation
+          CALL pmci_update_new
+       ENDIF
+
     ENDIF
-!
-!-- Correct the w top-BC in nest domains to ensure mass conservation.
-!-- Copy the interpolated/anterpolated boundary values to the _p
-!-- arrays, too, to make sure the interpolated/anterpolated boundary
-!-- values are carried over from one RK inner step to another.
-!-- These actions must not be done for the root domain.
-    IF ( nest_domain )  THEN
-       CALL pmci_ensure_nest_mass_conservation
-       CALL pmci_update_new
-    ENDIF
-#endif
 
 #if defined( __dvrp_graphics )
@@ -366,11 +373,11 @@
           CALL timestep
 
-#if defined( PMC_ACTIVE )
-!
-!--       TO_DO: try to give more detailed and meaningful comments here
-!--       Server side must be called first
-          CALL pmci_server_synchronize
-          CALL pmci_client_synchronize
-#endif
+          IF ( nested_run )  THEN
+!
+!--          TO_DO: try to give more detailed and meaningful comments here
+!--          Server side must be called first
+             CALL pmci_server_synchronize
+             CALL pmci_client_synchronize
+          ENDIF
        ENDIF
 
@@ -694,45 +701,47 @@
           CALL swap_timelevel
 
-#if defined( PMC_ACTIVE )
-!
-!--       TO_DO: try to give more meaningful comments here
-!--       Domain nesting
-!--       Note that the nesting operations are omitted intentionally on the
-!--       first two RK-substeps.
-          CALL cpu_log( log_point(60), 'nesting', 'start' )
-!
-!--       From server to client commmunication ( direction=SERVER_TO_CLIENT )
-          CALL pmci_server_datatrans( server_to_client )
-          CALL pmci_client_datatrans( server_to_client )
-
-          IF ( nesting_mode == 'two-way' )  THEN
-!
-!--          From client to server commmunication ( direction=CLIENT_TO_SERVER )
-             CALL pmci_server_datatrans( client_to_server )
-             CALL pmci_client_datatrans( client_to_server )
-!
-!--          Exchange_horiz is needed for all server-domains after the
-!--          anterpolation
-             CALL exchange_horiz( u, nbgp )
-             CALL exchange_horiz( v, nbgp )
-             CALL exchange_horiz( w, nbgp )
-             CALL exchange_horiz( pt, nbgp )
-             IF ( humidity  .OR.  passive_scalar )  THEN
-                CALL exchange_horiz( q, nbgp )
-             ENDIF
-             IF ( .NOT. constant_diffusion )  CALL exchange_horiz( e, nbgp )
-          ENDIF
-!
-!--       Correct the w top-BC in nest domains to ensure mass conservation.
-!--       This action must never be done for the root domain.
-          IF ( nest_domain )  THEN
-             CALL pmci_ensure_nest_mass_conservation
-!
-!--          pmc_update_new is not necessary if nesting is made at each substep.
-             CALL pmci_update_new
-          ENDIF
-
-          CALL cpu_log( log_point(60), 'nesting', 'stop' )
-#endif
+          IF ( nested_run )  THEN
+!
+!--          TO_DO: try to give more meaningful comments here
+!--          Domain nesting
+!--          Note that the nesting operations are omitted intentionally on the
+!--          first two RK-substeps.
+             CALL cpu_log( log_point(60), 'nesting', 'start' )
+!
+!--          From server to client commmunication ( direction=SERVER_TO_CLIENT )
+             CALL pmci_server_datatrans( server_to_client )
+             CALL pmci_client_datatrans( server_to_client )
+
+             IF ( nesting_mode == 'two-way' )  THEN
+!
+!--             From client to server commmunication ( direction=CLIENT_TO_SERVER )
+                CALL pmci_server_datatrans( client_to_server )
+                CALL pmci_client_datatrans( client_to_server )
+!
+!--             Exchange_horiz is needed for all server-domains after the
+!--             anterpolation
+                CALL exchange_horiz( u, nbgp )
+                CALL exchange_horiz( v, nbgp )
+                CALL exchange_horiz( w, nbgp )
+                CALL exchange_horiz( pt, nbgp )
+                IF ( humidity  .OR.  passive_scalar )  THEN
+                   CALL exchange_horiz( q, nbgp )
+                ENDIF
+                IF ( .NOT. constant_diffusion )  CALL exchange_horiz( e, nbgp )
+             ENDIF
+!
+!--          Correct the w top-BC in nest domains to ensure mass conservation.
+!--          This action must never be done for the root domain.
+             IF ( nest_domain )  THEN
+                CALL pmci_ensure_nest_mass_conservation
+!
+!--             pmc_update_new is not necessary if nesting is made at each
+!--             substep
+                CALL pmci_update_new
+             ENDIF
+
+             CALL cpu_log( log_point(60), 'nesting', 'stop' )
+
+          ENDIF
 
 !
@@ -1148,8 +1157,5 @@
 !
 !--    Output elapsed simulated time in form of a progress bar on stdout
-!--    TO_DO: should be done by root domain later
-#if ! defined( PMC_ACTIVE )
        IF ( myid == 0 )  CALL output_progress_bar
-#endif
 
        CALL cpu_log( log_point_s(10), 'timesteps', 'stop' )
@@ -1158,8 +1164,5 @@
     ENDDO   ! time loop
 
-!-- TO_DO: should be done by root domain later
-#if ! defined( PMC_ACTIVE )
     IF ( myid == 0 )  CALL finish_progress_bar
-#endif
 
 #if defined( __dvrp_graphics )
